Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-1.6-compat
# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0


Name:           jradius
Version:        1.0.0
Release:        alt1_1jpp6
Epoch:          0
Summary:        Java Radius client and server framework
License:        LGPL
Url:            http://jradius.net
Group:          Development/Java
Source0:        %{name}-%{version}.tar.gz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         jradius-core-pom.patch
Patch1:         jradius-example-pom.patch
Patch2:         jradius-applet-pom.patch
Patch3:         jradius-JRadiusWiFiClient.patch
Patch4:         jradius-WISPrClient.patch
Patch5:         jradius-pom.patch

BuildRequires: jpackage-utils >= 1.7.5
BuildRequires: ant >= 0:1.6.5
BuildRequires: maven2 >= 0:2.0.7
BuildRequires: maven2-plugin-antrun
BuildRequires: maven2-plugin-assembly
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-dependency
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-resources
BuildRequires: maven-surefire-plugin

BuildRequires: bouncycastle-provider
BuildRequires: ehcache
BuildRequires: gnu-crypto
BuildRequires: gnu-getopt
BuildRequires: ipdr
BuildRequires: jakarta-commons-chain
BuildRequires: jakarta-commons-configuration
BuildRequires: jakarta-commons-lang
BuildRequires: java-plugin
BuildRequires: spring2-context
BuildRequires: spring2-context-support


Requires: bouncycastle-provider
Requires: ehcache
Requires: gnu-crypto
Requires: gnu-getopt
Requires: ipdr
Requires: jakarta-commons-chain
Requires: jakarta-commons-configuration
Requires: jakarta-commons-lang
Requires: spring2-context
Requires: spring2-context-support

Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%if ! %{gcj_support}
BuildArch:      noarch
%endif


%description
JRadius is an open-source Java RADIUS client and server 
framework. The JRadius client helps you to implement RADIUS
authentication and accounting in your Java application. The
JRadius server is a RADIUS processing engine accessed 
through the rlm_jradius module in FreeRADIUS. JRadius was 
originally developed by David Bird while with PicoPoint, 
B.V. and development continues with a new version available 
from subversion.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
# remove all binary libs
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5

%build
cp %{SOURCE1} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p ${MAVEN_REPO_LOCAL}/bouncycastle
ln -sf $(build-classpath bouncycastle/bcprov) ${MAVEN_REPO_LOCAL}/bouncycastle/bcprov-jdk15.jar

export MAVEN_OPTS="-Xmx256M"

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.test.failure.ignore=true \
        install 

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        javadoc:javadoc

%install
%{__rm} -fr %{buildroot}
%{__install} -d -m 755 %{buildroot}%{_datadir}/maven2/poms
%{__install} -d -m 755 %{buildroot}%{_javadir}/%{name}
%{__install} -m 644 pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.jradius-jradius.pom
%add_to_maven_depmap net.jradius %{name} %{version} JPP/%{name} %{name}


%{__install} -m 644 applet/target/%{name}-applet-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/applet-%{version}.jar
%{__install} -m 644 applet/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.jradius-applet.pom
%add_to_maven_depmap net.jradius %{name}-applet %{version} JPP/%{name} applet

%{__install} -m 644 client/target/%{name}-client-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/client-%{version}.jar
%{__install} -m 644 client/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.jradius-client.pom
%add_to_maven_depmap net.jradius %{name}-client %{version} JPP/%{name} client

%{__install} -m 644 core/target/%{name}-core-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/core-%{version}.jar
%{__install} -m 644 core/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.jradius-core.pom
%add_to_maven_depmap net.jradius %{name}-core %{version} JPP/%{name} core

%{__install} -m 644 dictionary/target/%{name}-dictionary-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/dictionary-%{version}.jar
%{__install} -m 644 dictionary/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.jradius-dictionary.pom
%add_to_maven_depmap net.jradius %{name}-dictionary %{version} JPP/%{name} dictionary

%{__install} -m 644 example/target/%{name}-example-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/example-%{version}.jar
%{__install} -m 644 example/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.jradius-example.pom
%add_to_maven_depmap net.jradius %{name}-example %{version} JPP/%{name} example

%{__install} -m 644 extended/target/%{name}-extended-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/extended-%{version}.jar
%{__install} -m 644 extended/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.jradius-extended.pom
%add_to_maven_depmap net.jradius %{name}-extended %{version} JPP/%{name} extended

%{__install} -m 644 server/target/%{name}-server-%{version}.jar \
             %{buildroot}%{_javadir}/%{name}/server-%{version}.jar
%{__install} -m 644 server/pom.xml \
             %{buildroot}%{_datadir}/maven2/poms/JPP.jradius-server.pom
%add_to_maven_depmap net.jradius %{name}-server %{version} JPP/%{name} server

(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

# javadoc
%{__install} -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr html/* %{buildroot}%{_javadocdir}/%{name}-%{version}
(cd %{buildroot}%{_javadocdir} && ln -sf %{name}-%{version} %{name})

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%files
%doc LICENSE
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/*
%{_javadocdir}/%{name}

%changelog
* Tue Mar 17 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.0.0-alt1_1jpp6
- first build

